## openvswitch 3.0.0

=== debian/changelog ===
openvswitch (3.0.0-0ubuntu1) kinetic; urgency=medium

  [ Frode Nordahl ]
  * New upstream version 3.0.0
  * Merge packaging from Debian.
  * d/openvswitch-common.install: Add OVSDB local-config man page
    and ovsschema.
  * d/control: python3-openvswitch is now an architecture dependent
    package.
  * d/rules: Fix linkage of the python C extension.
  * d/rules: Refresh skip test list for ppc64el.
  * d/copyright: Drop superfluous file patterns.

  [ James Page ]
  * d/control: Add missing shlib:Depends for python3-openvswitch.
  * d/control: openvswitch-ipsec -> python3-openvswitch binary:Version
    due to switch to architecture specific Python module.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Mon, 22 Aug 2022 14:24:44 +0100

openvswitch (3.0.0~git20220718.e2e8d7c-0ubuntu1) kinetic; urgency=medium

  * New upstream snapshot from 3.0 release branch.
  * d/copyright: Tidy for removal of datapath component.
  * d/rules: Enable native json extension for OVS Python module
    (LP: #1982002).
  * d/rules: Drop obsolete installation for Python 2 versions.

 -- James Page <james.page@ubuntu.com>  Mon, 18 Jul 2022 16:43:55 +0100

openvswitch (2.17.2-4) unstable; urgency=medium

  * Upload to unstable.

 -- Luca Boccassi <bluca@debian.org>  Fri, 19 Aug 2022 20:59:13 +0100

openvswitch (2.17.2-3) experimental; urgency=medium

  * d/p/0001-ovsdb-idl-Support-write-only-changed-IDL-monitor-mod.patch:
    Cherry pick feature to improve scalability and performance which is
    required for OVN 22.03.1 (LP: #1980809).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Mon, 01 Aug 2022 15:55:37 +0200

openvswitch (2.17.2-2) experimental; urgency=medium

  * d/rules: exclude new tests that are failing on hppa
  * d/rules: exclude new tests that are failing on riscv64 (Closes:
    #1009969)
  * d/rules: exclude new tests that are failing on sparc64
  * d/clean: add trailing slash to directories
  * Do not install python3/ovtest in two packages (Closes: #1014749)
  * d/rules: simplify Python handling

 -- Luca Boccassi <bluca@debian.org>  Thu, 14 Jul 2022 14:16:53 +0100

openvswitch (2.17.2-1) experimental; urgency=medium

  [ Team upload ]
  * Update to 2.17.2 and merge Debian and Ubuntu packaging

  [ Christian Ehrhardt ]
    - d/control: merge Debian's uploaders list and extend it
    - d/control: bump Standards-Version (no changes needed)
    - d/control: set salsa based Vcs tags
    - d/control: switch to debhelper-compat (= 13)
    - d/control: add misc:Pre-Depends for compat 13 to pkgs with services
    - d/rules: dh_missing now covers --list-missing
    - d/rules: switch service start to compat 13 style
    - d/control: add breaks and replaces to match the file reorg seen by
      Debian between various packages
      + openvswitch-common to openvswitch-testcontroller
      - openvswitch-common to openvswitch-test
      - python3-openvswitch to openvswitch-test
    - d/control, d/openvswitch-dev.install: drop openvswitch-dev
      [Unused and not considered ABI stable, related to the
       drop of --enable-shared]
  * autopkgtest: also check service status
  * d/t/control: add isolation-machine as modules are involved
  * d/openvswitch-switch.{preinst,postinst,postrm}: take over
    /etc/default/openvswitch-switch

  [ Luca Boccassi ]
  * Merge debian/yoga with debian/2.17.0-0ubuntu1 into debian/experimental
    - retaining git history of both projects
    - retaining additions in Debian like maint script permissions,
      whitespace fixes and many other small things
    - drop --enable-shared
  * d/control: set Rules-Requires-Root
  * Remove dependency on automake1.10, obsolete
  * d/control: remove XS-Testsuite
  * Suggest python3:any when an optional python script is shipped
  * Add missing Pre-Depends
  * openswitch-source: add APL2 NOTICE to docs
  * Override some Lintian false positives
  * Override Lintian error about lack of +ds suffix
  * Enable hardening compiler options
  * autopkgtest: drop kernel module test
  * d/rules: use dh-exec instead of manually copying files
  * d/rules: drop remaining python2 logic
  * d/rules: adjust indentation
  * use d/clean instead of manual rm
  * d/rules: drop obsolete autoreconf snippets
  * d/rules: use execute_before/after
  * d/rules: switch to dh-sequence build dependencies
  * d/rules: use --sourcedirectory
  * Drop manual openvswitch-dbg package
  * d/rules: do not mark python test modules as executable
  * Override Lintian warning about autogenerated sources
  * Add dependency on lsb-base for sysv-only packages
  * ovsdb-server.service: switch from syslog.target to journald dependency
  * d/rules: add test exclusions for other archs from debian/yoga

  [ Frode Nordahl ]
  * d/rules: Allow use of EXTRA_CONFIGURE_OPTS
  * d/dkms.conf.in, d/rules.modules: drop unused
  * d/tests/*: Replace `echo -n` with `printf
  * d/automake.mk: Update list of files for upstream distribution
  * d/ifupdown.sh: Replace calls to ifconfig with `ip link`
  * Handle missing files
  * d/rules: Initialize DEB_HOST_ARCH when not set
  * Remove uneccessary whitespace in patches

 -- Luca Boccassi <bluca@debian.org>  Tue, 05 Jul 2022 13:02:40 +0100

## openvswitch 3.0.3

=== debian/changelog ===
openvswitch (3.0.3-0ubuntu0.22.10.3~cloud3) jammy-zed; urgency=medium

  * d/p/lp-2018500-tc-Fix-crash-on-malformed-reply-from-kernel.patch:
    Fix crash on malformed reply from kernel (LP: #2018500).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Wed, 27 Sep 2023 16:14:45 +0200

openvswitch (3.0.3-0ubuntu0.22.10.3~cloud2) jammy-zed; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Thu, 13 Jul 2023 18:52:50 +0000

openvswitch (3.0.3-0ubuntu0.22.10.3) kinetic-security; urgency=medium

  * SECURITY UPDATE: remote traffic denial of service via crafted packets
    with IP proto 0
    - debian/patches/CVE-2023-1668.patch: Always mask ip proto field in
      include/openvswitch/meta-flow.h, lib/meta-flow.c,
      ofproto/ofproto-dpif-xlate.c, tests/ofproto-dpif.at,
      tests/ofproto.at, tests/packet-type-aware.at.
    - CVE-2023-1668

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Apr 2023 09:38:44 -0400

openvswitch (3.0.3-0ubuntu0.22.10.2) kinetic-security; urgency=medium

  * No change rebuild in -security pocket as new version contains fix for
    CVE-2022-4337 and CVE-2022-4338.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 22 Feb 2023 08:50:59 -0500

openvswitch (3.0.3-0ubuntu0.22.10.1) kinetic; urgency=medium

  * New upstream version 3.0.3 (LP: #2003059).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Tue, 17 Jan 2023 10:13:06 +0100

openvswitch (3.0.1-0ubuntu0.22.10.1) kinetic; urgency=medium

  * New upstream point release 3.0.1 (LP: #1995288).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Mon, 31 Oct 2022 16:52:28 +0100

=== debian/control ===
Source: openvswitch
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Open vSwitch developers <dev@openvswitch.org>
Uploaders:
 Simon Horman <horms@debian.org>,
 Thomas Goirand <zigo@debian.org>,
 Michal Arbet <michal.arbet@ultimum.io>,
 Luca Boccassi <bluca@debian.org>,
 Christian Ehrhardt <christian.ehrhardt@canonical.com>,
Build-Depends:
 autoconf (>= 2.64),
 automake (>= 1.10) | automake1.10,
 bzip2,
 debhelper-compat (= 13),
 dh-exec,
 dh-python,
 dh-sequence-python3,
 dh-sequence-sphinxdoc,
 graphviz,
 iproute2,
 libcap-ng-dev,
 libdbus-1-dev [amd64 i386 ppc64el arm64],
 libdpdk-dev (>= 21.11) [amd64 i386 ppc64el arm64],
 libnuma-dev [amd64 i386 ppc64el arm64],
 libpcap-dev [amd64 i386 ppc64el arm64],
 libssl-dev,
 libtool,
 libunbound-dev,
 openssl,
 pkg-config,
 procps,
 python3-all-dev,
 python3-setuptools,
 python3-sortedcontainers,
 python3-sphinx,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: http://openvswitch.org/
Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/openvswitch
Vcs-Git: git://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/openvswitch
XS-Testsuite: autopkgtest

Package: openvswitch-common
Architecture: linux-any
Depends:
 openssl,
 python3-six,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 ethtool,
 openvswitch-doc,
Breaks:
 openvswitch-switch (<< 2.13.0~git20200212.15ae9db33-0ubuntu2~),
Replaces:
 openvswitch-switch (<< 2.13.0~git20200212.15ae9db33-0ubuntu2~),
Description: Open vSwitch common components
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 openvswitch-common provides components required by both openvswitch-switch
 and openvswitch-testcontroller.

Package: openvswitch-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: Open vSwitch documentation
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 This package provides documentation for configuration and use
 of Open vSwitch.

Package: openvswitch-ipsec
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 iproute2,
 openvswitch-common (= ${binary:Version}),
 openvswitch-switch (= ${binary:Version}),
 python3-openvswitch (= ${binary:Version}),
 strongswan,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: python3:any
Description: Open vSwitch IPsec tunneling support
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 This package provides IPsec tunneling support for OVS tunnels.

Package: openvswitch-pki
Architecture: all
Depends:
 openvswitch-common (<< ${source:Version}.1~),
 openvswitch-common (>= ${source:Version}),
 ${misc:Depends},
Description: Open vSwitch public key infrastructure dependency package
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 openvswitch-pki provides PKI (public key infrastructure) support for
 Open vSwitch switches and controllers, reducing the risk of
 man-in-the-middle attacks on the Open vSwitch network infrastructure.

Package: openvswitch-source
Architecture: all
Depends:
 ${misc:Depends},
Description: Open vSwitch source code
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 This package contains the full Open vSwitch source code to support
 use with the Open Virtual Network (OVN) build.

Package: openvswitch-switch
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends},
Depends:
 kmod | module-init-tools,
 netbase,
 openvswitch-common (= ${binary:Version}),
 procps,
 python3-netifaces,
 python3-openvswitch (>= ${source:Version}),
 uuid-runtime,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Open vSwitch switch implementations
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 openvswitch-switch provides the userspace components and utilities for
 the Open vSwitch kernel-based switch.

Package: openvswitch-switch-dpdk
Architecture: amd64 arm64 i386 ppc64el
Pre-Depends: ${misc:Pre-Depends},
Depends:
 dpdk,
 openvswitch-switch (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Enhances:
 openvswitch-switch,
Description: DPDK enabled Open vSwitch switch implementation
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 openvswitch-switch provides the userspace components and utilities for
 the Open vSwitch kernel-based switch.
 .
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package provides a DPDK enabled implementation of the ovs-vswitchd
 binary.

Package: openvswitch-test
Architecture: all
Depends:
 python3-twisted,
 ${misc:Depends},
 ${python3:Depends},
Description: Open vSwitch test package
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 This package contains utilities that are useful to diagnose
 performance and connectivity issues in Open vSwitch setup.

Package: openvswitch-testcontroller
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 lsb-base,
 openvswitch-common (= ${binary:Version}),
 openvswitch-pki (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Simple controller for testing OpenFlow setups
 This controller enables OpenFlow switches that connect to it to act
 as MAC-learning Ethernet switches.  It can be used for initial
 testing of OpenFlow networks.  It is not a necessary or desirable
 part of a production OpenFlow deployment.

Package: openvswitch-vtep
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 lsb-base,
 lsb-release,
 openvswitch-common (>= ${binary:Version}),
 openvswitch-switch (>= ${binary:Version}),
 python3-openvswitch (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests: python3:any
Description: Open vSwitch VTEP utilities
 Open vSwitch is a production quality, multilayer, software-based, Ethernet
 virtual switch. It is designed to enable massive network automation through
 programmatic extension, while still supporting standard management interfaces
 and protocols (e.g. NetFlow, sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In
 addition, it is designed to support distribution across multiple physical
 servers similar to VMware's vNetwork distributed vswitch or Cisco's Nexus
 1000V.
 .
 This package provides utilities that are useful to interact with a
 VTEP-configured database and a VTEP emulator.

Package: python3-openvswitch
Architecture: linux-any
Section: python
Depends:
 python3-six,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python 3 bindings for Open vSwitch
 Open vSwitch is a production quality, multilayer, software-based,
 Ethernet virtual switch. It is designed to enable massive network
 automation through programmatic extension, while still supporting
 standard management interfaces and protocols (e.g. NetFlow, IPFIX,
 sFlow, SPAN, RSPAN, CLI, LACP, 802.1ag). In addition, it is designed
 to support distribution across multiple physical servers similar to
 VMware's vNetwork distributed vswitch or Cisco's Nexus 1000V.
 .
 This package contains the full Python 3 bindings for Open vSwitch
 database.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -fPIC

%:
	dh $@

execute_after_dh_autoreconf:
	patch -f --no-backup-if-mismatch -i $(CURDIR)/debian/ltmain-whole-archive.diff build-aux/ltmain.sh

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
PARALLEL =
endif

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)

override_dh_auto_configure:
	test -d _debian || mkdir _debian
	cd _debian && ( \
		test -e Makefile || \
		../configure --prefix=/usr --localstatedir=/var --enable-ssl \
					 --sysconfdir=/etc \
					 $(DATAPATH_CONFIGURE_OPTS) \
					 $(EXTRA_CONFIGURE_OPTS) \
					 )
ifneq (,$(filter i386 amd64 ppc64el arm64, $(DEB_HOST_ARCH)))
	test -d _dpdk || mkdir _dpdk
	cd _dpdk && ( \
		test -e Makefile || \
        ../configure --prefix=/usr --localstatedir=/var --enable-ssl \
                     --with-dpdk=shared --sysconfdir=/etc \
					 $(DATAPATH_CONFIGURE_OPTS) \
					 $(EXTRA_CONFIGURE_OPTS) \
					 )
endif


# NOTE(jamespage): by default, just run all tests
TEST_LIST =
TEST_LIST_DPDK =

# ppc64el:
# 784: tunnel - concomitant incompatible tunnels on different ports FAILED (tunnel.at:1030)
ifneq (,$(filter ppc64el, $(DEB_HOST_ARCH)))
TEST_LIST = 1-783 785-
TEST_LIST_DPDK = $(TEST_LIST)
endif # ppc64el

# armhf:
#  30: bfd - check that BFD works together with RSTP   FAILED (bfd.at:829)
ifneq (,$(filter armhf, $(DEB_HOST_ARCH)))
TEST_LIST = 1-29 31-
TEST_LIST_DPDK = $(TEST_LIST)
endif # armhf

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	if $(MAKE) -C _debian check TESTSUITEFLAGS='$(PARALLEL) $(TEST_LIST)' || \
                $(MAKE) -C _debian check TESTSUITEFLAGS='--recheck'; then :; \
	else \
		cat _debian/tests/testsuite.log; \
		exit 1; \
	fi
# Skip DPDK testing on arm64 as builders don't have crc32 support
# which is used in aarch64 based crc optimization in ovs >= 2.12.0~
ifneq (,$(filter i386 amd64 ppc64el, $(DEB_HOST_ARCH)))
	if $(MAKE) -C _dpdk check TESTSUITEFLAGS='$(PARALLEL) $(TEST_LIST_DPDK)' || \
				$(MAKE) -C _dpdk check TESTSUITEFLAGS='--recheck'; then :; \
	else \
		cat _dpdk/tests/testsuite.log; \
		exit 1; \
	fi
endif # i386/amd64/ppc64el
endif # nocheck

override_dh_auto_build:
	dh_auto_build --sourcedirectory=_debian -- dist distdir=openvswitch
	dh_auto_build --sourcedirectory=_debian
ifneq (,$(filter i386 amd64 ppc64el arm64, $(DEB_HOST_ARCH)))
	dh_auto_build --sourcedirectory=_dpdk
endif

execute_before_dh_auto_clean:
	find . -name "*.pyc" -delete

override_dh_auto_install:
	dh_auto_install --sourcedirectory=_debian

execute_after_dh_install:
	set -e; \
	cd python; \
	export PKG_CONFIG_PATH=$(CURDIR)/debian/tmp/usr/lib/pkgconfig; \
	export PKG_CONFIG_SYSROOT_DIR=$(CURDIR)/debian/tmp; \
	export PKG_CONFIG_SYSTEM_INCLUDE_PATH=/; \
	export PKG_CONFIG_SYSTEM_LIBRARY_PATH=/; \
	enable_shared=no \
	extra_cflags="`pkg-config --cflags libopenvswitch`" \
	extra_libs="-Wl,-Bstatic -lopenvswitch -Wl,-Bdynamic `pkg-config --libs --static libopenvswitch`" \
	python3 setup.py install --install-layout=deb \
		--root $(CURDIR)/debian/python3-openvswitch; \
	cd ..

override_dh_installinit:
	dh_installinit --restart-after-upgrade
	dh_installinit -popenvswitch-switch --name=ovsdb-server --no-start
	dh_installinit -popenvswitch-switch --name=ovs-vswitchd --no-start
	dh_installinit -popenvswitch-switch --name=ovs-record-hostname --no-start

override_dh_installsystemd:
	dh_installsystemd -popenvswitch-switch --name=ovsdb-server --no-start
	dh_installsystemd -popenvswitch-switch --name=ovs-vswitchd --no-start
	dh_installsystemd -popenvswitch-switch --name=ovs-record-hostname --no-start
	dh_installsystemd --restart-after-upgrade -Xovs-vswitchd.service -Xovsdb-server.service -Xovs-record-hostname.service

override_dh_strip:
	dh_strip --dbgsym-migration='openvswitch-dbg (<< 3.0.0~)'

# Helper target for creating snapshots from upstream git
DATE=$(shell date +%Y%m%d)
# Upstream branch to track
BRANCH=branch-3.0
VERSION=3.0.0

get-orig-snapshot:
	rm -Rf openvswitch-upstream
	git clone --branch $(BRANCH) --depth 1 https://github.com/openvswitch/ovs openvswitch-upstream
	cd openvswitch-upstream && \
		export COMMIT=`git rev-parse --short HEAD` && \
		git archive --format tgz --prefix=openvswitch-$(VERSION)~git$(DATE).$$COMMIT/ \
			-o ../../openvswitch_$(VERSION)~git$(DATE).$$COMMIT.orig.tar.gz $(BRANCH)
	rm -Rf openvswitch-upstream

## openvswitch 3.1.0

=== utilities/docker/Makefile ===
#export OVS_BRANCH=branch-2.11
#export OVS_VERSION=2.11
#export KERNEL_VERSION=4.15.0-54-generic
#export DISTRO=debian
#export GITHUB_SRC=https://github.com/openvswitch/ovs.git
#export DOCKER_REPO=openvswitch/ovs

# Example:
#   make build
#   make push

REPO = ${DOCKER_REPO}
tag = ${OVS_VERSION}_${DISTRO}_${KERNEL_VERSION}

build: ;docker build -t ${REPO}:${tag} --build-arg DISTRO=${DISTRO} \
--build-arg OVS_BRANCH=${OVS_BRANCH} \
--build-arg KERNEL_VERSION=${KERNEL_VERSION} \
--build-arg GITHUB_SRC=${GITHUB_SRC} -f ${DISTRO}/Dockerfile .

.PHONY: build

push: ;docker push ${REPO}:${tag}

=== debian/changelog ===
openvswitch (3.1.0-2+deb12u1) bookworm-security; urgency=medium

  * CVE-2023-5366: A flaw was found in Open vSwitch that allows ICMPv6 Neighbor
    Advertisement packets between virtual machines to bypass OpenFlow rules.
    This issue may allow a local attacker to create specially crafted packets
    with a modified or spoofed target IP address field that can redirect ICMPv6
    traffic to arbitrary IP addresses. Added upstream patch: "Fix missing masks
    on a final stage with ports trie".
  * CVE-2023-3966: Invalid memory access in Geneve with HW offload. Added
    upstream patch: netdev-offload-tc: Check geneve metadata length
    (Closes: #1063492).

 -- Thomas Goirand <zigo@debian.org>  Sun, 18 Feb 2024 16:46:26 +0100

openvswitch (3.1.0-2) unstable; urgency=high

  * CVE-2023-1668: Remote traffic denial of service via crafted packets with IP
    proto 0. Applied upstream patch: ofproto-dpif-xlate: Always mask ip proto
    field (Closes: #1034042).

 -- Thomas Goirand <zigo@debian.org>  Tue, 11 Apr 2023 11:54:40 +0200

openvswitch (3.1.0-1) unstable; urgency=medium

  [ Luca Boccassi ]
  * Drop dependencies on lsb-base, deprecated
  * Bump Standards-Version to 4.6.2, no changes

  [ Frode Nordahl ]
  * Update upstream source from tag 'upstream/3.1.0'
  * d/rules: Set branch for snapshots to branch-3.1.
  * d/debian/openvswitch-switch.install, d/debian/openvswitch-
    test.install: Move USDT scripts to test package.

 -- Luca Boccassi <bluca@debian.org>  Tue, 21 Feb 2023 22:02:16 +0000

openvswitch (3.1.0~git20230108.006e1c6-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/3.1.0_git20230108.006e1c6'.
  * d/p/CVE-2022-4337and8: Drop, included in snapshot.
  * d/p/af-xdp*: Drop, included in snapshot.
  * d/openvswitch-switch.install: Add USDT scripts.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Mon, 09 Jan 2023 07:47:45 +0100

openvswitch (3.1.0~git20221212.739bcf2-4) unstable; urgency=high

  * Add dpdk support for riscv64 (Closes: #1027329).
  * CVE-2022-4337 & CVE-2022-4338: Out-of-Bounds Read and Integer Underflow in
    Organization Specific TLV. Added upstream patches (Closes: #1027273).

 -- Thomas Goirand <zigo@debian.org>  Tue, 03 Jan 2023 10:06:22 +0100

openvswitch (3.1.0~git20221212.739bcf2-3) unstable; urgency=medium

  * salsa-ci.yml: build on unstable
  * Upload to unstable

 -- Luca Boccassi <bluca@debian.org>  Sat, 17 Dec 2022 14:02:44 +0000

openvswitch (3.1.0~git20221212.739bcf2-2) experimental; urgency=medium

  * Exclude xdp-tools build dep on ports where it's not available

 -- Luca Boccassi <bluca@debian.org>  Fri, 16 Dec 2022 14:16:37 +0000

openvswitch (3.1.0~git20221212.739bcf2-1) experimental; urgency=medium

  * Update upstream source from snapshot 'upstream/3.1.0_git20221212.739bcf2'
  * d/rules: Update snapshot target version
  * d/gbp.conf: Set experimental branch
  * d/control: Bump DPDK dependency to 22.11
  * d/control: Add build dependencies for AF_XDP
  * d/p/af-xdp-*: Add patches to build AF_XDP support by default

 -- Frode Nordahl <frode.nordahl@canonical.com>  Wed, 14 Dec 2022 15:25:27 +0100

openvswitch (3.0.1-1) experimental; urgency=medium

  [ Frode Nordahl ]
  * Update upstream source from tag 'upstream/3.0.1'
  * d/p/0001-ovsdb-idl-Support-write-only-changed-IDL-monitor-mod.patch:
    Drop
  * d/openvswitch-common.install: Add ovsdb.local-config man page
  * d/openvswitch-switch.install: Add local-config.ovsschema
  * d/rules: Build the Python JSON C extension
  * d/control: Make python3-openvswitch a binary package, drop python3-six
    dependency
  * d/copyright: Drop references to XenServer
  * d/openvswitch-switch.README.Debian: Drop reference to out of tree
    kernel module
  * d/control: Add suggested optional dependencies for Python OVS flow
    parsing
  * d/copyright: Drop references to datapath/*
  * d/copyright.in: Sync with upstream repository
  * d/rules: Add comment about the explicit -fPIC for this package

  [ Luca Boccassi ]
  * Drop setuptools-import-order.patch, distutils is no longer used

 -- Luca Boccassi <bluca@debian.org>  Thu, 24 Nov 2022 18:42:45 +0000

openvswitch (2.17.2-5) unstable; urgency=medium

  * Add OOMScoreAdjust=-900 for a number of vital services.
  * Add setuptools-import-order.patch.

 -- Thomas Goirand <zigo@debian.org>  Tue, 27 Sep 2022 10:59:53 +0200

openvswitch (2.15.0+ds1-11) UNRELEASED; urgency=medium

  * Blacklist more unit tests on mipsel:
    - 1036: ofproto-dpif - select group with weights FAILED (ofproto-dpif.at:787)
    - 1072: ofproto-dpif - controller action without megaflows FAILED (ofproto-dpif.at:2145)
  * Blacklist more unit tests on riscv64 (same as above).

 -- Thomas Goirand <zigo@debian.org>  Mon, 03 Jan 2022 16:50:02 +0100

openvswitch (2.15.0+ds1-10) unstable; urgency=medium

  * CVE-2021-36980: use-after-free in decode_NXAST_RAW_ENCAPAdd. Add upstream
    patch (Closes: #991308).

 -- Thomas Goirand <zigo@debian.org>  Mon, 03 Jan 2022 12:07:24 +0100

openvswitch (2.15.0+ds1-9) unstable; urgency=medium

  * Blacklist unit test 27 on armel.

 -- Thomas Goirand <zigo@debian.org>  Wed, 24 Nov 2021 13:01:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: openvswitch
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Open vSwitch developers <dev@openvswitch.org>
+Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
 Uploaders:
  Simon Horman <horms@debian.org>,
  Thomas Goirand <zigo@debian.org>,
@@ -11,7 +10,7 @@
  Christian Ehrhardt <christian.ehrhardt@canonical.com>,
 Build-Depends:
  autoconf (>= 2.64),
- automake (>= 1.10) | automake1.10,
+ automake (>= 1.10),
  bzip2,
  debhelper-compat (= 13),
  dh-exec,
@@ -20,14 +19,16 @@
  dh-sequence-sphinxdoc,
  graphviz,
  iproute2,
+ libbpf-dev,
  libcap-ng-dev,
- libdbus-1-dev [amd64 i386 ppc64el arm64],
- libdpdk-dev (>= 21.11) [amd64 i386 ppc64el arm64],
- libnuma-dev [amd64 i386 ppc64el arm64],
- libpcap-dev [amd64 i386 ppc64el arm64],
+ libdbus-1-dev [amd64 i386 ppc64el arm64 riscv64],
+ libdpdk-dev (>= 22.11) [amd64 i386 ppc64el arm64 riscv64],
+ libnuma-dev [amd64 i386 ppc64el arm64 riscv64],
+ libpcap-dev [amd64 i386 ppc64el arm64 riscv64],
  libssl-dev,
  libtool,
  libunbound-dev,
+ libxdp-dev (>= 1.2.9~) [!alpha !arc !hppa !ia64 !m68k !sh4],
  openssl,
  pkg-config,
  procps,
@@ -35,18 +36,16 @@
  python3-setuptools,
  python3-sortedcontainers,
  python3-sphinx,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://openvswitch.org/
-Vcs-Browser: https://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/openvswitch
-Vcs-Git: git://git.launchpad.net/~ubuntu-server-dev/ubuntu/+source/openvswitch
-XS-Testsuite: autopkgtest
+Vcs-Browser: https://salsa.debian.org/openstack-team/third-party/openvswitch/-/tree/debian/experimental
+Vcs-Git: https://salsa.debian.org/openstack-team/third-party/openvswitch.git
 
 Package: openvswitch-common
 Architecture: linux-any
 Depends:
  openssl,
- python3-six,
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
@@ -99,6 +98,10 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Suggests: python3:any
+Breaks:
+ openvswitch-common (<< 2.17~),
+Replaces:
+ openvswitch-common (<< 2.17~),
 Description: Open vSwitch IPsec tunneling support
  Open vSwitch is a production quality, multilayer, software-based,
  Ethernet virtual switch. It is designed to enable massive network
@@ -154,11 +157,15 @@
  openvswitch-common (= ${binary:Version}),
  procps,
  python3-netifaces,
- python3-openvswitch (>= ${source:Version}),
+ python3-openvswitch (>= ${binary:Version}),
  uuid-runtime,
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
+Breaks:
+ openvswitch-common (<< 2.17~),
+Replaces:
+ openvswitch-common (<< 2.17~),
 Description: Open vSwitch switch implementations
  Open vSwitch is a production quality, multilayer, software-based,
  Ethernet virtual switch. It is designed to enable massive network
@@ -172,7 +179,7 @@
  the Open vSwitch kernel-based switch.
 
 Package: openvswitch-switch-dpdk
-Architecture: amd64 arm64 i386 ppc64el
+Architecture: amd64 arm64 i386 ppc64el riscv64
 Pre-Depends: ${misc:Pre-Depends},
 Depends:
  dpdk,
@@ -206,6 +213,14 @@
  python3-twisted,
  ${misc:Depends},
  ${python3:Depends},
+Breaks:
+ python3-openvswitch (<< 2.17~),
+ openvswitch-common (<< 2.17~),
+ openvswitch-switch (<< 3.1.0-1~),
+Replaces:
+ python3-openvswitch (<< 2.17~),
+ openvswitch-common (<< 2.17~),
+ openvswitch-switch (<< 3.1.0-1~),
 Description: Open vSwitch test package
  Open vSwitch is a production quality, multilayer, software-based,
  Ethernet virtual switch. It is designed to enable massive network
@@ -220,9 +235,12 @@
 
 Package: openvswitch-testcontroller
 Architecture: linux-any
+Breaks:
+ openvswitch-common (<< 2.17~),
+Replaces:
+ openvswitch-common (<< 2.17~),
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
- lsb-base,
  openvswitch-common (= ${binary:Version}),
  openvswitch-pki (= ${source:Version}),
  ${misc:Depends},
@@ -237,15 +255,18 @@
 Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends:
- lsb-base,
  lsb-release,
  openvswitch-common (>= ${binary:Version}),
  openvswitch-switch (>= ${binary:Version}),
- python3-openvswitch (>= ${source:Version}),
+ python3-openvswitch (>= ${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
 Suggests: python3:any
+Breaks:
+ openvswitch-common (<< 2.17~),
+Replaces:
+ openvswitch-common (<< 2.17~),
 Description: Open vSwitch VTEP utilities
  Open vSwitch is a production quality, multilayer, software-based, Ethernet
  virtual switch. It is designed to enable massive network automation through
@@ -262,10 +283,12 @@
 Architecture: linux-any
 Section: python
 Depends:
- python3-six,
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
+ ${misc:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends},
+Suggests:
+ python3-netaddr,
+ python3-pyparsing,
 Description: Python 3 bindings for Open vSwitch
  Open vSwitch is a production quality, multilayer, software-based,
  Ethernet virtual switch. It is designed to enable massive network

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# While -fPIC is often the default, we explicitly enable it for this package
# because it is a requirement for successful linking the static libopenvswitch
# with shared libraries used for the Python JSON C extension.
#
# Ref: https://patchwork.ozlabs.org/project/openvswitch/patch/20220725121939.2710272-5-i.maximets@ovn.org/
export DEB_CFLAGS_MAINT_APPEND = -fPIC

%:
	dh $@

execute_after_dh_autoreconf:
	patch -f --no-backup-if-mismatch -i $(CURDIR)/debian/ltmain-whole-archive.diff build-aux/ltmain.sh

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
PARALLEL =
endif

PYTHON3S:=$(shell py3versions -vr)
DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)

override_dh_auto_configure:
	test -d _debian || mkdir _debian
	cd _debian && ( \
		test -e Makefile || \
		../configure --prefix=/usr --localstatedir=/var --enable-ssl \
					 --sysconfdir=/etc \
					 $(DATAPATH_CONFIGURE_OPTS) \
					 $(EXTRA_CONFIGURE_OPTS) \
					 )
ifneq (,$(filter i386 amd64 ppc64el arm64 riscv64, $(DEB_HOST_ARCH)))
	test -d _dpdk || mkdir _dpdk
	cd _dpdk && ( \
		test -e Makefile || \
        ../configure --prefix=/usr --localstatedir=/var --enable-ssl \
                     --with-dpdk=shared --sysconfdir=/etc \
					 $(DATAPATH_CONFIGURE_OPTS) \
					 $(EXTRA_CONFIGURE_OPTS) \
					 )
endif


# NOTE(jamespage): by default, just run all tests
TEST_LIST =
TEST_LIST_DPDK =

# armhf:
#  30: bfd - check that BFD works together with RSTP   FAILED (bfd.at:829)
ifneq (,$(filter armhf, $(DEB_HOST_ARCH)))
TEST_LIST = 1-29 31-
TEST_LIST_DPDK = $(TEST_LIST)
endif # armhf

# mipsel:
#    20: bfd - bfd decay FAILED (bfd.at:396)
#    21: bfd - bfd decay
#   917: ofproto - asynchronous message control (OpenFlow 1.2) (ofproto.at:3183)
#   918: ofproto - asynchronous message control (OpenFlow 1.3) FAILED (ovs-macros.at:241)
#   927: ofproto - asynchronous message control (OpenFlow 1.3)  FAILED (ofproto.at:3405)
#   919: ofproto - asynchronous message control (OpenFlow 1.4) FAILED (ovs-ofctl)
#  1035: ofproto-dpif - select group with weights
#  1036: ofproto-dpif - select group with weights        FAILED (ofproto-dpif.at:787)
#  1057: ofproto-dpif - controller action without megaflows FAILED (ofproto-dpif.at:1893)
#  1069: ofproto-dpif - controller action without megaflows
#  1102: ofproto-dpif - continuation - resubmit FAILED (ovs-macros.at:241)
#  1071: ofproto-dpif - controller action without megaflows
#  1072: ofproto-dpif - controller action without megaflows FAILED (ofproto-dpif.at:2145)
#  1136: ofproto-dpif - sFlow packet sampling - LACP structures
ifneq (,$(filter mipsel, $(DEB_HOST_ARCH)))
TEST_LIST = 1-19 22-531 533-916 920-926 928-1020 1022-1034 1037-1056 1058-1068 1070 1073-1101 1103-1135 1137-
TEST_LIST_DPDK = $(TEST_LIST)
endif # mipsel

# mips64el:
#    20: bfd - bfd decay FAILED (bfd.at:396)
#  1033: ofproto-dpif - select group with weights
#  1035: ofproto-dpif - select group with weights
#  1057: ofproto-dpif - controller action without megaflows FAILED (ofproto-dpif.at:1893)
#  1021: ofproto-dpif - select group with weights        FAILED (ofproto-dpif.at:535)
#  1069: ofproto-dpif - controller action without megaflows
ifneq (,$(filter mips64el, $(DEB_HOST_ARCH)))
TEST_LIST = 1-19 22-531 533-1020 1022-1032 1034 1037-1056 1058-1068 1070 1072-1120 1122-
TEST_LIST_DPDK = $(TEST_LIST)
endif # mips64el

# armel:
#    27: bfd - check that BFD works together with RSTP   FAILED (bfd.at:830)
#  1021: ofproto-dpif - select group with weights        FAILED (ofproto-dpif.at:535)
#  1123: ofproto-dpif - sFlow packet sampling - LACP structures FAILED (ofproto-dpif.at:6643)
ifneq (,$(filter armel, $(DEB_HOST_ARCH)))
TEST_LIST = 1-19 22-26 28-531 533-1020 1022-1056 1058-1122 1124-
TEST_LIST_DPDK = $(TEST_LIST)
endif #armel

# arm64:
#   159: ofp-actions - inconsistent MPLS actions         FAILED (ofp-actions.at:819)
#  1021: ofproto-dpif - select group with weights        FAILED (ofproto-dpif.at:535)
#  1057: ofproto-dpif - controller action without megaflows FAILED (ofproto-dpif.at:1893)
ifneq (,$(filter arm64, $(DEB_HOST_ARCH)))
TEST_LIST = 1-19 21-158 160-531 533-1020 1022-1056 1058-
TEST_LIST_DPDK = $(TEST_LIST)
endif #arm64

# alpha
#  2724: ovn -- dns lookup : 1 HV, 2 LS, 2 LSPs/LS       FAILED (ovn.at:7451)
#  2728: ovn -- vlan traffic for external network with distributed router gateway port FAILED (ovn.at:8563)
#  2737: ovn -- IPv6 periodic RA                         FAILED (ovn.at:9916)
ifneq (,$(filter alpha, $(DEB_HOST_ARCH)))
TEST_LIST = 1-19 22-531 533-2723 2725-2727 2729-2736 2738-
TEST_LIST_DPDK = $(TEST_LIST)
endif #alpha

# hppa
#    20: bfd - bfd decay FAILED (bfd.at:314)
#   758: tunnel - input with matching tunnel mask        FAILED (tunnel.at:132)
#   847: ofproto - bundle del group (OpenFlow 1.5) FAILED (ofproto.at:813)
#   850: ofproto - bundle remove group buckets FAILED (ofproto.at:1005)
#   916: ofproto - asynchronous message control (OpenFlow 1.0) FAILED (ovs-macros.at:241)
#   917: ofproto - asynchronous message control (OpenFlow 1.2) FAILED (ovs-macros.at:241)
#   919: ofproto - asynchronous message control (OpenFlow 1.4) FAILED (ovs-ofctl)
#   918: ofproto - asynchronous message control (OpenFlow 1.3) FAILED (ofproto.at:3371)
#   942: ofproto - flow monitoring pause and resume FAILED (ofproto.at:4850)
#   945: ofproto - asynchronous message control (OpenFlow 1.3) FAILED (ovs-macros.at:242)
#   946: ofproto - asynchronous message control (OpenFlow 1.4) FAILED (ofproto.at:3638)
#  1033: ofproto-dpif - masked set-field into metadata FAILED (ofproto-dpif.at:860)
#  1021: ofproto-dpif - select group with weights FAILED (ofproto-dpif.at:535)
#  1053: ofproto-dpif - balance-tcp bonding rebalance after link state changes FAILED (ofproto-dpif.at:482)
#  1057: ofproto-dpif - controller action without megaflows FAILED (ofproto-dpif.at:1893)
#  1102: ofproto-dpif - continuation - resubmit FAILED (ovs-macros.at:241)
#  1105: ofproto-dpif - continuation - mirroring FAILED (ovs-macros.at:241)
#  1123: ofproto-dpif - sFlow packet sampling - LACP structures FAILED (ofproto-dpif.at:6643)
#  1155: ofproto-dpif - continuation - resubmit - OpenFlow10 FAILED (ovs-macros.at:242)
#  1156: ofproto-dpif - continuation - resubmit - OpenFlow13 FAILED (ovs-macros.at:242)
#  1159: ofproto-dpif - continuation - goto_table - OpenFlow10 FAILED (ovs-macros.at:242)
#  1160: ofproto-dpif - continuation - goto_table - OpenFlow13 FAILED (ovs-macros.at:242)
#  1161: ofproto-dpif - continuation - write_metadata - OpenFlow10 FAILED (ovs-macros.at:242)
#  1162: ofproto-dpif - continuation - write_metadata - OpenFlow13 FAILED (ovs-macros.at:242)
#  1181: ofproto - bundle with variable bfd/cfm config   FAILED (ofproto-dpif.at:8749)
#  1187: ofproto-dpif - sFlow packet sampling - LACP structures FAILED (ofproto-dpif.at:7205)
#  1209: ofproto-dpif - conntrack - zones                FAILED (ofproto-dpif.at:9898)
#  1735: ovsdb-server combines updates on backlogged connections FAILED (ovsdb-server.at:1205)
#  1806: ovsdb-server transaction history size           FAILED (ovsdb-server.at:1282)
#  2193: RSTP - dummy interface FAILED (rstp.at:210)
ifneq (,$(filter hppa, $(DEB_HOST_ARCH)))
TEST_LIST = 1-19 22-531 533-757 759-846 848-849 851-915 920-941 943-944 947-1020 1022-1052 1054-1056 1058-1101 1103-1104 1106-1122 1124-1154 1157-1158 1163-1180 1182-1186 1188-1208 1210-1734 1736-1805 1807-2192 2194-
TEST_LIST_DPDK = $(TEST_LIST)
endif #hppa

# sparc64
#    20: bfd - bfd decay                                 FAILED (bfd.at:396)
#    26: bfd - check that BFD works together with RSTP   FAILED (bfd.at:829)
#   478: fuzz regression - ofp_print_fuzzer-5395207246839808 FAILED (fuzz-regression.at:12)
#   927: ofproto - bundle packet-out makes bundle commit to fail(OpenFlow 1.4) FAILED (ofproto.at:2181)

=== debian/tests/control ===
Tests: vanilla dpdk
Depends:
 iperf,
 mininet (>= 2.2.0~),
 openvswitch-switch,
 openvswitch-switch-dpdk [amd64 i386],
 openvswitch-testcontroller,
Restrictions: needs-root rw-build-tree isolation-machine

## openvswitch 3.1.2

=== debian/changelog ===
openvswitch (3.1.2-0ubuntu0.23.04.1) lunar; urgency=medium

  * Update upstream source from tag 'upstream/3.1.2' (LP: #2025319).
  * d/p/CVE-2023-1668_ofproto-dpif-xlate_Always_mask_ip_proto_field.patch:
    Drop, included in new upstream version.
  * d/gbp.conf: Set appropriate branch for Lunar.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Thu, 29 Jun 2023 15:25:10 +0200

openvswitch (3.1.0-1ubuntu1) lunar; urgency=medium

  * SECURITY UPDATE: remote traffic denial of service via crafted packets
    with IP proto 0
    - debian/patches/CVE-2023-1668.patch: Always mask ip proto field in
      include/openvswitch/meta-flow.h, lib/meta-flow.c,
      ofproto/ofproto-dpif-xlate.c, tests/ofproto-dpif.at,
      tests/ofproto.at, tests/packet-type-aware.at.
    - CVE-2023-1668

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Apr 2023 09:34:14 -0400

## openvswitch 3.1.3

=== debian/changelog ===
openvswitch (3.1.3-0ubuntu0.23.04.1~cloud2) jammy-antelope; urgency=medium

  * d/control: Fix upgrade bug from zed -> antelope UCA by updating
    Breaks/Replaces for openvswitch-switch (LP: #2077406).

 -- Frode Nordahl <fnordahl@ubuntu.com>  Mon, 30 Sep 2024 13:21:00 +0100

openvswitch (3.1.3-0ubuntu0.23.04.1) lunar; urgency=medium

  * New upstream point release (LP: #2039907).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Fri, 20 Oct 2023 05:48:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openvswitch
 Section: net
 Priority: optional
-Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
 Uploaders:
  Simon Horman <horms@debian.org>,
  Thomas Goirand <zigo@debian.org>,
@@ -163,9 +164,9 @@
  ${python3:Depends},
  ${shlibs:Depends},
 Breaks:
- openvswitch-common (<< 2.17~),
-Replaces:
- openvswitch-common (<< 2.17~),
+ openvswitch-common (<< 3.1.0-1~),
+Replaces:
+ openvswitch-common (<< 3.1.0-1~),
 Description: Open vSwitch switch implementations
  Open vSwitch is a production quality, multilayer, software-based,
  Ethernet virtual switch. It is designed to enable massive network

## openvswitch 3.1.4

=== debian/changelog ===
openvswitch (3.1.4-1+deb12u1) bookworm-security; urgency=medium

  * CVE-2023-3966: Invalid memory access in Geneve with HW offload. Upgraded
    to upstream release 3.1.4 containing the fix (Closes: #1063492).
  * Removed CVE-2023-1668_ofproto-dpif-xlate_Always_mask_ip_proto_field.patch
    applied upstream.

 -- Thomas Goirand <zigo@debian.org>  Sat, 10 Feb 2024 12:41:32 +0100

## openvswitch 3.2.0

=== debian/changelog ===
openvswitch (3.2.0-1) unstable; urgency=medium

  * Team upload.
  * Update upstream source from tag 'upstream/3.2.0'
  * d/p/docs-*: Update patch for #1042358.
  * d/p/lib-fatal-signal-Drop-logging-of-failed-dummy-backtr.patch: Drop
    unnecessary debug logging to fix armhf build (LP: #2032623).

 -- Frode Nordahl <frode.nordahl@canonical.com>  Tue, 22 Aug 2023 10:43:20 +0200

openvswitch (3.1.2-4) unstable; urgency=medium

  * Fix ifupdown.sh (Closes: #1039601).

 -- Thomas Goirand <zigo@debian.org>  Fri, 11 Aug 2023 11:15:19 +0200

openvswitch (3.1.2-3) unstable; urgency=medium

  * Re-add openvswitch-common.postinst to clean-up obsolete alternative,
    thanks to Andreas Beckmann for it (Closes: #1036569).

 -- Thomas Goirand <zigo@debian.org>  Fri, 11 Aug 2023 10:55:22 +0200

openvswitch (3.1.2-2) unstable; urgency=medium

  * Add patches from Colin Watson to repair the docs (Closes: #1042358):
    - docs-1-Wrap_more_table_entries_in_text_blocks.patch
    - docs-2-Shorten_overly-wide_table_heading.patch
    - docs-3-Tweak_width_of_name_column_in_field_property.patch
    - docs-4-Fix_rendering_of_VLAN_Comparison_Chart.patch
    - docs-5-Run_tbl_preprocessor_in_manpage-check_rule.patch

 -- Thomas Goirand <zigo@debian.org>  Mon, 07 Aug 2023 16:57:37 +0200

openvswitch (3.1.2-1) unstable; urgency=medium

  * Team upload.
  * Update upstream source from tag 'upstream/3.1.2'.
  * d/p/CVE-2023-1668_ofproto-dpif-xlate_Always_mask_ip_proto_field.patch:
    Drop, included in new upstream version.
  * d/control: Add libnuma-dev on s390x for AF_XDP.
  * d/p/drop-old-autopkgtest: Drop old autopkgtest.
  * debian/tests: Run upstream system tests as autopkgtests.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Tue, 27 Jun 2023 19:13:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: openvswitch
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
+Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
 Uploaders:
  Simon Horman <horms@debian.org>,
  Thomas Goirand <zigo@debian.org>,
@@ -24,7 +23,7 @@
  libcap-ng-dev,
  libdbus-1-dev [amd64 i386 ppc64el arm64 riscv64],
  libdpdk-dev (>= 22.11) [amd64 i386 ppc64el arm64 riscv64],
- libnuma-dev [amd64 i386 ppc64el arm64 riscv64],
+ libnuma-dev [amd64 i386 ppc64el arm64 riscv64 s390x],
  libpcap-dev [amd64 i386 ppc64el arm64 riscv64],
  libssl-dev,
  libtool,
@@ -164,9 +163,9 @@
  ${python3:Depends},
  ${shlibs:Depends},
 Breaks:
- openvswitch-common (<< 3.1.0-1~),
-Replaces:
- openvswitch-common (<< 3.1.0-1~),
+ openvswitch-common (<< 2.17~),
+Replaces:
+ openvswitch-common (<< 2.17~),
 Description: Open vSwitch switch implementations
  Open vSwitch is a production quality, multilayer, software-based,
  Ethernet virtual switch. It is designed to enable massive network

## openvswitch 3.2.1

=== debian/changelog ===
openvswitch (3.2.1-0ubuntu0.23.10.1) mantic; urgency=medium

  * New upstream point release (LP: #2039906).
  * d/p/docs-*: Drop, included in point release.
  * d/p/lib-fatal-signal-Drop-logging-of-failed-dummy-backtr.patch: Drop,
    included in point release.
  * d/p/tests*.patch: Cherry-pick in-flight patches for tests that fixes
    autopkgtest failures.
  * d/t/*-skip-tests.txt: Add flaky test to list.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Sun, 22 Oct 2023 11:20:53 +0200
